<?php

use QUI\Locations\Locator;
use QUI\Utils\Security\Orthos;
use QUI\Locations\Locator\Handler;

/**
 * Get a list of geo points for all active locations
 *
 * @pararm array $filters (optional) - Location Filter data
 * @param array $project (optional)
 * @param int $siteId (optional)
 * @return array
 */
QUI::$Ajax->registerFunction(
    'package_quiqqer_locations_ajax_frontend_Locator_getAllLocationPoints',
    function ($filters, $project = null, $siteId = null) {
        $searchParams = [];

        if (!empty($filters)) {
            $filters                    = Orthos::clearArray(\json_decode($filters, true));
            $searchParams['allowedIds'] = Handler::getAllowedLocationIds($filters);
        }

        $locations = Locator::getAllLocationPoints($searchParams);
        $Site      = null;

        if (!empty($project) && !empty($siteId)) {
            try {
                $Project = QUI::getProjectManager()->decode($project);
                $Site    = $Project->get((int)$siteId);
            } catch (\Exception $Exception) {
                QUI\System\Log::writeException($Exception);
            }
        }

        return [
            'locations'  => $locations,
            'viewCenter' => Handler::getDefaultMapViewCenter($Site)
        ];
    },
    ['filters', 'project', 'siteId']
);
