<?php

use QUI\Locations\Handler\Locations as LocationsHandler;

/**
 * Get data of a single location
 *
 * @param int $locationId - location ID
 * @return bool - success
 */
QUI::$Ajax->registerFunction(
    'package_quiqqer_locations_ajax_locations_get',
    function ($locationId) {
        try {
            return LocationsHandler::getLocation((int)$locationId)->toArray();
        } catch (\Exception $Exception) {
            QUI\System\Log::writeException($Exception);

            throw new \QUI\Locations\Exception([
                'quiqqer/locations',
                'exception.ajax.locations.get.location_load_error',
                [
                    'locationId' => $locationId
                ]
            ]);
        }
    },
    ['locationId'],
    'Permission::checkAdminUser'
);
