<?php

use QUI\Utils\Security\Orthos;
use QUI\Utils\Grid;
use QUI\Locations\Handler\Locations as LocationsHandler;

/**
 * Get list of locations
 *
 * @param array $searchParams - search parameters
 * @return string
 */
QUI::$Ajax->registerFunction(
    'package_quiqqer_locations_ajax_locations_getList',
    function ($searchParams) {
        $searchParams = Orthos::clearArray(
            json_decode($searchParams, true)
        );

        $locations = LocationsHandler::search($searchParams);

        $Grid = new Grid($searchParams);

        return $Grid->parseResult(
            $locations,
            LocationsHandler::search($searchParams, true)
        );
    },
    ['searchParams'],
    'Permission::checkAdminUser'
);
