<?php

use QUI\Locations\Handler\LocationAPIs;

/**
 * Update execution time of location API
 *
 * @return int $id - API ID
 */
QUI::$Ajax->registerFunction(
    'package_quiqqer_locations_ajax_locationsapis_execute',
    function ($id) {
        try {
            LocationAPIs::execute((int)$id);
        } catch (QUI\Locations\Exception $Exception) {
            QUI::getMessagesHandler()->addError(
                QUI::getLocale()->get(
                    'quiqqer/locations',
                    'message.ajax.locationsapis.execute.error',
                    array(
                        'locationApiId' => $id,
                        'error'         => $Exception->getMessage()
                    )
                )
            );

            return false;
        } catch (\Exception $Exception) {
            QUI\System\Log::addError(
                'AJAX :: package_quiqqer_locations_ajax_locationsapis_execute -> '
                . $Exception->getMessage()
            );

            QUI::getMessagesHandler()->addError(
                QUI::getLocale()->get(
                    'quiqqer/locations',
                    'message.locations.general.error'
                )
            );

            return false;
        }

        QUI::getMessagesHandler()->addSuccess(
            QUI::getLocale()->get(
                'quiqqer/locations',
                'message.ajax.locationsapis.execute.success',
                array(
                    'locationApiId' => $id
                )
            )
        );

        return true;
    },
    array('id'),
    'Permission::checkAdminUser'
);
