<?php

use QUI\Locations\Handler\Locations;
use QUI\Locations\Controls\LocationView;
use QUI\Locations\Controls\Locator as LocatorControl;
use QUI\Locations\Handler\LocationSearch as LocationSearchHandler;
use QUI\Locations\Locator\Handler as LocatorHandler;
use QUI\Utils\Security\Orthos;

$locationIds = false;
$filterData  = [];
$radius      = false;

if (!empty($_REQUEST['locationsearch'])) {
    $radius      = LocationSearchHandler::getSearchRadius();
    $locationIds = LocationSearchHandler::getLocationIdsByRequest();

    // Determine filter data for Locator filters
    $filterControls = LocatorHandler::getFilterControls();

    foreach ($filterControls as $idHash => $FilterControl) {
        if ($FilterControl instanceof \QUI\LocationCategories\Controls\CategoryFilter
            && !empty($_REQUEST['cat_id'])
            && \is_numeric($_REQUEST['cat_id'])) {
            $filterData[$idHash] = [(int)$_REQUEST['cat_id']];
        }
    }
}

$Locator      = false;
$LocationView = false;

if (!empty($_GET['id'])) {
    try {
        $LocationView = new LocationView([
            'Location' => Locations::getLocation((int)$_GET['id'])
        ]);
    } catch (\Exception $Exception) {
        QUI\System\Log::writeDebugException($Exception);
    }
}

if (empty($Location)) {
    $Locator = new LocatorControl([
        'locationIds'          => $locationIds,
        'filterData'           => $filterData,
        'radius'               => $radius,
        'locationSearchString' => empty($_REQUEST['search_string']) ? false : Orthos::clear($_REQUEST['search_string']),
        'display'              => $Site->getAttribute('quiqqer.locations.locator.settings.template'),
        'locationImageList'    => $Site->getAttribute('quiqqer.locations.locator.list.show_images')
    ]);
}

$Engine->assign([
    'Site'         => $Site,
    'Locator'      => $Locator,
    'LocationView' => $LocationView
]);

/**
 * Type of used control in site type
 */
$LOCATOR_CONTROL_TYPE = '';

if ($Locator) {
    $LOCATOR_CONTROL_TYPE = 'locator-controltype-locator';
}

if ($LocationView) {
    $LOCATOR_CONTROL_TYPE = 'locator-controltype-locationview';
}

$Engine->assign([
    'Site'                 => $Site,
    'Locator'              => $Locator,
    'LocationView'         => $LocationView,
    'LOCATOR_CONTROL_TYPE' => $LOCATOR_CONTROL_TYPE
]);
